Attribute VB_Name = "modTrainerAPI"
' API
Private Const PROCESS_ALL_ACCESS As Long = &H1F0FFF
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function WriteProcessMemory Lib "kernel32" (ByVal hProcess As Long, ByVal lpBaseAddress As Any, ByRef lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal Classname As String, ByVal WindowName As String) As Long
Private Declare Function ReadProcessMem Lib "kernel32" Alias "ReadProcessMemory" (ByVal hProcess As Long, ByVal lpBaseAddress As Any, ByRef lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
'Public Declare Function GetKeyPress Lib "user32" Alias "GetAsyncKeyState" (ByVal key As Long) As Integer
Public Declare Function GetAsyncKeyState Lib "user32.dll" (ByVal vKey As Long) As Integer
Public Declare Sub keybd_event Lib "user32.dll" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'The following = for mouse movement
'Usage: Call SetCursorPos (555, 333)
Public Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long


'OLE Constants
Global Const OLE_CREATE_NEW = 0
Global Const OLE_CREATE_FROM_FILE = 1
Global Const OLE_COPY = 4
Global Const OLE_PASTE = 5
Global Const OLE_UPDATE = 6
Global Const OLE_ACTIVATE = 7
Global Const OLE_EXECUTE = 8
Global Const OLE_CLOSE = 9
Global Const OLE_DELETE = 10
Global Const OLE_SAVE_TO_FILE = 11
Global Const OLE_READ_FROM_FILE = 12
Global Const OLE_CONVERT_TO_TYPE = 13
Global AddedNew
Global xFilename
'End OLE Constants

Enum soundConstants 'Start soundConstants
   snd_sync = &H0 ' play synchronously (default)
   SND_ASYNC = &H1 ' play asynchronously
   SND_NODEFAULT = &H2 ' silence (!default) if sound not found
   SND_MEMORY = &H4 ' pszSound points to a memory file
   SND_LOOP = &H8 ' loop the sound until next sndPlaySound
   SND_NOSTOP = &H10 ' don't stop any currently playing sound
   SND_NOWAIT = &H2000 ' don't wait if the driver is busy
   SND_ALIAS = &H10000 ' name is a registry alias
   SND_ALIAS_ID = &H110000 ' alias is a predefined ID
   SND_FILENAME = &H20000 ' name is file name
   SND_RESOURCE = &H40004 ' name is resource name or atom
   SND_PURGE = &H40 ' purge non-static events for task
   SND_APPLICATION = &H80 ' look for application specific association
End Enum 'End soundConstants

    'Window/Process Name Global Strings
    Public Const strWN = "White"
    Public Const strGameEXE = "White.exe"
    
    Dim lngGamePID As Long
    Dim lngHwndGameProc As Long
    
    'Process Stuffs
    Public ProcessHandle As Long
    Public bolConnected As Boolean
    Public bolEXEInMemory As Boolean

    'Trainer Info
    Public Const strTrainerName As String = "Black & White 2 v1.1 - Trainer "
    Public strTrainerVersion As String


Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
    (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal _
    lpDefault As String, ByVal lpReturnedString As String, ByVal _
    nSize As Long, ByVal lpFileName As String) As Long

' ----------------------- Enum --------------------------

Public Function GamePID() As Long
On Error GoTo EH
    Dim objWMI, objProcess, objProcesses
    Dim intCounter, intRetVal As Integer
    Dim bolTaskFound As Boolean
    bolEXEInMemory = False
    SetConnected
    Set objWMI = GetObject("winmgmts://.")
    If Err.Number <> 0 Then
        MsgBox "Could not contact WMI on this computer." & vbNewLine & "Attempting to find Black & White 2 by window insetad.", vbCritical, "WMI Problem"
        SetConnected
        GamePID2
        Exit Function
    End If
    Set objProcesses = objWMI.execquery("Select * from win32_process")
    If objProcesses.Count = 0 Then
        MsgBox "Could not enumerate processes on this computer.", vbCritical, "WMI Problem"
        SetConnected
        GamePID2
        Exit Function
    End If
    For Each objProcess In objProcesses
        bolTaskFound = False
        If UCase(objProcess.Name) = UCase(strGameEXE) Then
            bolEXEInMemory = True
            GamePID = objProcess.ProcessID
            ProcessHandle = OpenProcess(PROCESS_ALL_ACCESS, False, objProcess.ProcessID)
            If ProcessHandle = 0 Then
                If (bolConnected = True) Then
                    'MsgBox "Could not attach to the process, " & strGameEXE & vbNewLine & "Are you sure the game is even running?"
                End If
                SetConnected
            Else
                SetConnected
            End If
            Exit Function
        End If
    Next

Exit Function
EH:
GamePID2
Exit Function
End Function
Public Function GamePID2() As Long
On Error GoTo EH
Dim hwnd As Long
Dim ProcessID As Long
Dim ProcessHandle As Long
    ' Find game based on window name, rather then use WMI.
    hwnd = FindWindow(vbNullString, strWN)
    If hwnd = 0 Then
        MsgBox "Could not find process window!", vbCritical, "Write error"
        bolEXEInMemory = False
        SetConnected
        Exit Function
    End If
    bolEXEInMemory = True
    GetWindowThreadProcessId hwnd, ProcessID
    ProcessHandle = OpenProcess(PROCESS_ALL_ACCESS, False, ProcessID)
    If ProcessHandle = 0 Then
        'MsgBox "Could not get a process handle!", vbCritical, "Write error"
        SetConnected
        Exit Function
    End If
    SetConnected

Exit Function
EH:
MsgBox "An error occured while in the GamePID2 function." & vbNewLine & "Error Number: " & Err.Number & vbNewLine & "Error Description: " & Err.Description
SetConnected
Resume Next

End Function
' ----------------------- Enum --------------------------

'SetConnected is executed when the trainer makes or can't make a connection to the game.
'It does things like set the Status bar text, etc.
Public Function SetConnected()
Dim i As Integer

Select Case bolEXEInMemory
        Case Is = True
            frmMain.stBar.SimpleText = strGameEXE & " is in memory   -- "
            frmMain.cmdLaunchBW2.Enabled = False
            Case Is = False
            frmMain.stBar.SimpleText = strGameEXE & " is not in memory.  Trainer only functions while game is running   -- "
            frmMain.cmdLaunchBW2.Enabled = True
            ProcessHandle = 0
    End Select
    
    Select Case ProcessHandle
        Case Is = 0
            frmMain.tmrHotKeys.Enabled = False
            ResetCheckBoxes 3
            frmMain.stBar.SimpleText = frmMain.stBar.SimpleText & "  " & " Not Connected "
            frmMain.mnuProfileLoadFrom.Enabled = False
            frmMain.mnuProfileSaveTo.Enabled = False
            frmMain.HScroll_Age.Enabled = False
            frmMain.lblAge.Visible = False
            frmMain.lblCurWally.Visible = False
            frmMain.oleCurWally.Visible = True
            bolConnected = False
        Case Else
            ResetCheckBoxes 3
            frmMain.tmrHotKeys.Enabled = True
            frmMain.stBar.SimpleText = frmMain.stBar.SimpleText & "  " & " Connected "
            frmMain.stBar.Tag = frmMain.stBar.SimpleText
            frmMain.mnuProfileLoadFrom.Enabled = True
            frmMain.mnuProfileSaveTo.Enabled = True
            frmMain.lblCurWally.Visible = True
            frmMain.oleCurWally.Visible = False
            bolConnected = True
    End Select
End Function
Public Function ResetCheckBoxes(intWhich As Integer)
On Error GoTo EH
            
            If (intWhich = 1 Or intWhich = 3) Then
                For i = 0 To frmMain.CheckBox.Count - 1
                    frmMain.CheckBox(i).Value = 0
                Next i
            End If
            
            If (intWhich = 2 Or intWhich = 3) Then
                For i = 0 To frmMain.chkWonder.Count - 1
                    frmMain.chkWonder(i).Value = 0
                Next i
                For i = 0 To frmMain.chkResource.Count - 1
                    frmMain.chkResource(i).Value = 0
                Next i
                For i = 0 To frmMain.chkOther.Count - 1
                    frmMain.chkOther(i).Value = 0
                Next i
                frmMain.optStorehouse(0).Value = True
            End If
Exit Function
EH:
MsgBox "An error occured while in the ResetCheckBoxes function." & vbNewLine & "Error Number: " & Err.Number & vbNewLine & "Error Description: " & Err.Description
Resume Next
End Function

Public Function Read4Bytes(Offset As Long, ReadLen As Long) As Long
On Error GoTo EH
Dim Value As Long
   
    If ProcessHandle = 0 Then
        'Attempt to start Process Handling...
        GamePID
        If ProcessHandle = 0 Then
            Exit Function
        End If
        Exit Function
  
    End If
    
    If ReadLen < CLng(1&) Then
        ReadLen = CLng(4&)
    End If
    'ReadLen = CLng(ReadLen)
    ReadProcessMem ProcessHandle, Offset, Value, ReadLen, 0&
    Read4Bytes = Value

Exit Function
EH:
MsgBox "An error occured while in the Read4Bytes function." & vbNewLine & "Error Number: " & Err.Number & vbNewLine & "Error Description: " & Err.Description
Resume Next

End Function

Public Function Write4Bytes(Offset As Long, Value As Long) As Boolean
On Error GoTo EH

    If ProcessHandle = 0 Then
        'Attempt to start Process handle
        GamePID
        If ProcessHandle = 0 Then
            Exit Function
        End If
    End If
    
    Write4Bytes = WriteProcessMemory(ProcessHandle, Offset, Value, 4&, 0&)

Exit Function
EH:
MsgBox "An error occured while in the Write4Bytes function." & vbNewLine & "Error Number: " & Err.Number & vbNewLine & "Error Description: " & Err.Description
Resume Next

End Function

Public Function Write2Bytes(Offset As Long, Value As Long) As Boolean
On Error GoTo EH

    If ProcessHandle = 0 Then
        'Attempt to start Process handle
        GamePID
        If ProcessHandle = 0 Then
            Exit Function
        End If
    End If
    
    Write2Bytes = WriteProcessMemory(ProcessHandle, Offset, Value, 2, 0&)

Exit Function
EH:
MsgBox "An error occured while in the Write4Bytes function." & vbNewLine & "Error Number: " & Err.Number & vbNewLine & "Error Description: " & Err.Description
Resume Next

End Function
